<?php

namespace XIMSAPLUGIN\Element;

use Elementor\Controls_Manager;
use Elementor\Controls_Stack;
use Elementor\Group_Control_Typography;
use Elementor\Scheme_Typography;
use Elementor\Scheme_Color;
use Elementor\Group_Control_Border;
use Elementor\Repeater;
use Elementor\Widget_Base;
use Elementor\Utils;
use Elementor\Group_Control_Text_Shadow;
use Elementor\Plugin;

/**
 * Elementor button widget.
 * Elementor widget that displays a button with the ability to control every
 * aspect of the button design.
 *
 * @since 1.0.0
 */
class Project_Grid_View extends Widget_Base {

	/**
	 * Get widget name.
	 * Retrieve button widget name.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return string Widget name.
	 */
	public function get_name() {
		return 'ximsa_project_grid_view';
	}

	/**
	 * Get widget title.
	 * Retrieve button widget title.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return string Widget title.
	 */
	public function get_title() {
		return esc_html__( 'Project Grid View', 'ximsa' );
	}

	/**
	 * Get widget icon.
	 * Retrieve button widget icon.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return string Widget icon.
	 */
	public function get_icon() {
		return 'eicon-library-open';
	}

	/**
	 * Get widget categories.
	 * Retrieve the list of categories the button widget belongs to.
	 * Used to determine where to display the widget in the editor.
	 *
	 * @since  2.0.0
	 * @access public
	 * @return array Widget categories.
	 */
	public function get_categories() {
		return [ 'ximsa' ];
	}
	
	/**
	 * Register button widget controls.
	 * Adds different input fields to allow the user to change and customize the widget settings.
	 *
	 * @since  1.0.0
	 * @access protected
	 */
	protected function register_controls() {
		$this->start_controls_section(
			'project_grid_view',
			[
				'label' => esc_html__( 'Project Grid View', 'ximsa' ),
			]
		);
		$this->add_control(
			'number',
			[
				'label'   => esc_html__( 'Number of post', 'ximsa' ),
				'type'    => Controls_Manager::NUMBER,
				'default' => 3,
				'min'     => 1,
				'max'     => 100,
				'step'    => 1,
			]
		);
		$this->add_control(
			'cat_exclude',
			[
				'label'       => esc_html__( 'Exclude', 'ximsa' ),
				'label_block' => true,
				'type'        => Controls_Manager::TEXT,
				'description' => esc_html__( 'Exclude categories, etc. by ID with comma separated.', 'ximsa' ),
			]
		);
		$this->add_control(
			'query_order',
			[
				'label'   => esc_html__( 'Order', 'ximsa' ),
				'label_block' => true,
				'type'    => Controls_Manager::SELECT,
				'default' => 'DESC',
				'options' => array(
					'DESC' => esc_html__( 'DESC', 'ximsa' ),
					'ASC'  => esc_html__( 'ASC', 'ximsa' ),
				),
			]
		);
		$this->add_control(
			'query_orderby',
			[
				'label'   => esc_html__( 'Order By', 'ximsa' ),
				'label_block' => true,
				'type'    => Controls_Manager::SELECT,
				'default' => 'date',
				'options' => array(
					'date'       => esc_html__( 'Date', 'ximsa' ),
					'title'      => esc_html__( 'Title', 'ximsa' ),
					'menu_order' => esc_html__( 'Menu Order', 'ximsa' ),
					'rand'       => esc_html__( 'Random', 'ximsa' ),
				),
			]
		);
		$this->end_controls_section();
	}

	/**
	 * Render button widget output on the frontend.
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since  1.0.0
	 * @access protected
	 */
	protected function render() {
		$settings = $this->get_settings_for_display();
		$allowed_tags = wp_kses_allowed_html('post');
		
		$paged = get_query_var('paged');
		$paged = ximsa_set($_REQUEST, 'paged') ? esc_attr($_REQUEST['paged']) : $paged;
		
		$this->add_render_attribute( 'wrapper', 'class', 'templatepath-ximsa' );
		$args = array(
			'post_type'      => 'project',
			'posts_per_page' => ximsa_set( $settings, 'number' ),
			'orderby'        => ximsa_set( $settings, 'query_orderby' ),
			'order'          => ximsa_set( $settings, 'query_order' ),
			'paged'         => $paged
		);
		$terms_array = explode(",",ximsa_set( $settings, 'cat_exclude' ));
		if(ximsa_set( $settings, 'cat_exclude' )) $args['tax_query'] = array(array('taxonomy' => 'project_cat','field' => 'id','terms' => $terms_array,'operator' => 'NOT IN',));
		$allowed_tags = wp_kses_allowed_html('post');
		$query = new \WP_Query( $args );
		$t = '';
		$data_filtration = '';
		$data_posts = '';
		if ( $query->have_posts() ) 
		{
		ob_start();
		?>
  
		<?php 
            $count = 0; 
            $fliteration = array();
            while( $query->have_posts() ): $query->the_post();
            global  $post;
            $meta = ''; //printr($meta);
            $meta1 = ''; //_WSH()->get_meta();
            $post_terms = get_the_terms( get_the_id(), 'project_cat');// printr($post_terms); exit();
            foreach( (array)$post_terms as $pos_term ) $fliteration[$pos_term->term_id] = $pos_term;
            $temp_category = get_the_term_list(get_the_id(), 'project_cat', '', ', ');
            
            $post_terms = wp_get_post_terms( get_the_id(), 'project_cat'); 
            $term_slug = '';
            if( $post_terms ) foreach( $post_terms as $p_term ) $term_slug .= $p_term->slug.' ';
        	
			$term_list = wp_get_post_terms(get_the_id(), 'project_cat', array("fields" => "names"));
			$post_thumbnail_id = get_post_thumbnail_id($post->ID);
			$post_thumbnail_url = wp_get_attachment_url( $post_thumbnail_id );
			
            ?>
              
            <!-- Gallery Block Two -->
            <div class="gallery-block-two mix <?php echo esc_attr($term_slug); ?> col-lg-6 col-md-6 col-sm-12">
                <div class="inner-box">
                    <figure class="image-box">
                        <?php the_post_thumbnail('ximsa_570x590'); ?>
                        <!-- Overlay Box -->
                        <div class="overlay-box">
                            <div class="overlay-inner">
                                <div class="content">
                                    <div class="content-inner">
                                        <div class="title"><?php echo implode( ', ', (array)$term_list );?></div>
                                        <h3><a href="<?php echo esc_url(get_the_permalink());?>"><?php the_title(); ?></a></h3>
                                        <a href="<?php echo esc_url(get_post_meta( get_the_id(), 'project_link', true ));?>" class="arrow flaticon-right-arrow"></a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </figure>
                </div>
            </div>
               
			<?php endwhile;?>

            <?php wp_reset_postdata();
            $data_posts = ob_get_contents();
            ob_end_clean();
            
            ob_start();?>
            
		<?php $terms = get_terms(array('project_cat')); ?>

        <!-- Project Page Section -->
        <section class="project-page-section">
            <div class="auto-container">
                <!-- MixitUp Gallery -->
                <div class="mixitup-gallery">
                    
                    <!-- Filter -->
                    <div class="filters clearfix">
                        
                        <ul class="filter-tabs filter-btns text-center clearfix">
                            <li class="active filter" data-role="button" data-filter="all"><?php esc_attr_e('Show All', 'ximsa');?></li>
                            <?php foreach( $fliteration as $t ): ?>
                            <li class="filter" data-role="button" data-filter=".<?php echo esc_attr(ximsa_set( $t, 'slug' )); ?>"><?php echo ximsa_set( $t, 'name'); ?></li>
                            <?php endforeach;?>
                        </ul>
                        
                    </div>
                    
                    <div class="filter-list row clearfix">
                        <?php echo wp_kses($data_posts, true); ?> 
                    </div>
                </div>
            </div>
        </section>
        <!-- End About Section -->
        
		<?php }
	}
}